# Markdown Services

## About

This is a set of OS X services that contain the following commands:

  * **Markdown to HTML:** Replaces selected text written in Markdown with
    the corresponding HTML.
  * **HTML to Markdown:** The reverse of the previous: replaces selected
    HTML with the corresponding Markdown.
  * **Copy Markdown as RTF:** Copies the selected Markdown text to the
    clipboard as rich text, suitable for pasting into TextEdit or a word
    processor.
  * **Paste as Markdown:** The reverse of the previous: converts rich text on
    the clipboard into Markdown and pastes it into a document.

In addition, there are two MultiMarkdown-specific variants that require
MultiMarkdown 3 to be installed as `/usr/local/bin/markdown`. These services
will do nothing without MultiMarkdown. (Well, they'll give you errors, which
is something, but not something good.)

  * **MultiMarkdown to HTML**
  * **Copy MultiMarkdown as RTF**

The first four services are wrappers around other people's work, contained in
the services:

  * Markdown (John Gruber) v1.01
  * SmartyPants (John Gruber) v1.51
  * html2text.py (Aaron Swartz) v3.200.3

The last two services are wrappers around Fletcher Penney's work, _not_
contained in the services:

  * MultiMarkdown <http://fletcherpenney.net/multimarkdown/>

To the best of my knowledge, distribution as Automator-created OS X services
does not violate the licenses, as the source code is not only linked here but
readily available within the services if you open them in Automator. If you
have scripts installed in other places, or need to add command line options
and tweaks, you'll have to make those changes yourself--although if you need
to do that you probably know how, right?

## Installation

Copy the files to `~/Library/Services`. Ta-da!

## License

This package includes John Gruber's [Markdown][] and [SmartyPants][] and Aaron
Swartz's [html2text][] scripts. Those scripts are copyright to their
respective authors, and continue to be licensed under their chosen licenses.

The small bits of script I've done are Copyright (c) 2012 Watts Martin.
Redistributions in any form must retain the above copyright notice, the
attribution for included packages (with links), and the following disclaimer.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

[Markdown]: http://daringfireball.net/projects/markdown/
[SmartyPants]: http://daringfireball.net/projects/smartypants/
[html2text]: https://github.com/aaronsw/html2text